//AUTOR: FRANK D.
//DATE:  05.09.2018

#include <ESP8266WiFi.h>
#include <ArduinoOTA.h>
#include <ESPDMX.h>

const char *ssid = "LED_Network";
const char *password = "helloworld";

WiFiClient cli;
IPAddress ip (192, 168, 1, 1);
DMXESPSerial DMX;
char response = 0;


void setup() {
  ArduinoOTA.begin();
  WiFi.begin(ssid, password);
  WiFi.mode(WIFI_STA);
  pinMode(LED_BUILTIN, OUTPUT); //wird initiallisiert als debugger-ersatz
  digitalWrite(LED_BUILTIN, HIGH);

  while (WiFi.waitForConnectResult() != WL_CONNECTED) {
    ArduinoOTA.handle();
    delay(500);
  } //wartet solange bis eine Verbindung besteht
  DMX.init();
}

void loop() {
  ArduinoOTA.handle(); //dient nur zum programmieren über WLAN
  if (!cli.connect(ip, 80)) {
    digitalWrite(LED_BUILTIN, HIGH);
    return;
  } //bei fehlerhaften Verbindung wiederholt sich die schleife

  if (cli.read() != -1) { //SERVER SENDET FALSCHE SIGNALE || FEHLER!
    digitalWrite(LED_BUILTIN, LOW);
    delay(200);
    response = cli.read();

    switch (response) {
      case ('a'): ledshow(); break;
      default: response = NULL; break;
    }
  }
}

void ledshow() {

  DMX.write(4, 255);
  DMX.write(5, 0);
  DMX.write(6, 0);
  DMX.write(7, 255);

  for (int i = 1; i < 256; i++)
  {
    DMX.write(6, i);
    DMX.update();
  }

  for (int i = 255; i >= 0; i--)
  {
    DMX.write(6, i);
    DMX.update();
  }
}
